package de.accso.flexinale.besucherportal.api_in.web;

import de.accso.flexinale.backoffice_api_contract.api_contract.VorfuehrungRetriever;
import de.accso.flexinale.backoffice_api_contract.api_contract.model.FilmTO;
import de.accso.flexinale.backoffice_api_contract.api_contract.model.KinoSaalTO;
import de.accso.flexinale.backoffice_api_contract.api_contract.model.VorfuehrungTO;
import de.accso.flexinale.common.shared_kernel.Identifiable;
import de.accso.flexinale.common.shared_kernel.RawWrapper;
import de.accso.flexinale.security_api_contract.api_contract.BesucherRetriever;
import de.accso.flexinale.ticketing_api_contract.api_contract.KontingentBereitsAusgeschoepftException;
import de.accso.flexinale.ticketing_api_contract.api_contract.TicketRetriever;
import de.accso.flexinale.ticketing_api_contract.api_contract.Ticketing;
import de.accso.flexinale.ticketing_api_contract.api_contract.model.TicketTO;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.servlet.mvc.support.RedirectAttributes;

import java.time.LocalDateTime;
import java.util.List;

@Controller
public class TicketWebController {

    private static final Logger LOGGER = LoggerFactory.getLogger(TicketWebController.class);

    @Autowired
    private TicketRetriever ticketRetriever;

    @Autowired
    private VorfuehrungRetriever vorfuehrungRetriever;

    @Autowired
    private BesucherRetriever besucherRetriever;

    @Autowired
    private Ticketing ticketing;

    @GetMapping(value="/tickets")
    @PreAuthorize("hasRole('ROLE_BESUCHER')")
    public String listTickets(final Model model) {
        Identifiable.Id besucherId = besucherRetriever.getIdOfLoggedInBesucher();

        List<TicketTO> allTickets = ticketRetriever.ticketsByBesucherOrderByZeit(besucherId);

        List<List<VorfuehrungMitAnzahlTicketsTO>> ticketsByDay =
                TicketSorter.sortAndMapTicketsPerDay(allTickets, vorfuehrungRetriever);
        model.addAttribute("ticketsByDay", ticketsByDay);

        int totalNumberOfTickets = ticketRetriever.gesamtZahlDerTicketsFuer(besucherId);
        model.addAttribute("totalNumberOfTickets", totalNumberOfTickets);

        return ("tickets");
    }

    @PostMapping("/vorfuehrung/loeseGutscheineOnlineEin")
    @PreAuthorize("hasRole('ROLE_BESUCHER')")
    public String loeseGutscheineOnlineEin(
                       @RequestParam("vorfuehrungId") final String vId,
                       @RequestParam("anzahl")        final int anzahl,
                       final RedirectAttributes redirAttrs) {
        Identifiable.Id vorfuehrungId = Identifiable.Id.of(vId);
        Identifiable.Id besucherId = besucherRetriever.getIdOfLoggedInBesucher();

        VorfuehrungTO vorfuehrungTO = vorfuehrungRetriever.vorfuehrung(vorfuehrungId);
        Identifiable.Id filmId = vorfuehrungTO.film().id();

        try {
           ticketing.loeseGutscheineOnlineFuerVorfuehrungEin(vorfuehrungId, filmId, besucherId, anzahl);
        }
        catch (KontingentBereitsAusgeschoepftException kbaEx) {
            String message = "Kontingent exceeded: no %d tickets for Vorfuehrung %s and Besucher %s available".formatted(anzahl, vorfuehrungId, besucherId);
            LOGGER.info(message);

            redirAttrs.addFlashAttribute("error", "Keine %d Tickets mehr vorhanden".formatted(anzahl));
            return "redirect:/film/" + filmId.id();
        }
        redirAttrs.addFlashAttribute("success", "%d Ticket(s) erfolgreich gekauft".formatted(anzahl));
        return "redirect:/tickets";
    }
}

// class used to "flatten" Vorfuehrung and number of Tickets for Vorfuehrung for Clients
record VorfuehrungMitAnzahlTicketsTO(Zeit zeit, FilmTO film, KinoSaalTO kinoSaal, AnzahlTickets anzahlTickets) {
    public record Zeit(LocalDateTime raw) implements RawWrapper<LocalDateTime> {
        public Zeit(LocalDateTime raw) {
            this.raw = raw.withNano(0); // precision is second
        }
    }

    public record AnzahlTickets(Integer raw) implements RawWrapper<Integer> {}
}